'use strict';

var _which = require('which');

var _which2 = _interopRequireDefault(_which);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _module = require('module');

var _module2 = _interopRequireDefault(_module);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var modulesPath = _path2.default.join(_which2.default.sync('node'), '../../lib/node_modules');

var requireG = function requireG(module) {
  return require(_path2.default.join(requireG.modulesPath, module));
};

var isModule = function isModule(name) {
  return _fs2.default.existsSync(_path2.default.join(requireG.modulesPath, name, 'package.json'));
};

var modules = function modules() {
  var list = _fs2.default.readdirSync(requireG.modulesPath).filter(function (name) {
    return isModule(name);
  });

  return list;
};

var register = function register() {
  var regex = /^global:(.+)$/;
  var old = _module2.default._load;

  _module2.default._load = function (name) {
    var result = name.match(regex);

    if (result) {
      return old(_path2.default.join(requireG.modulesPath, result[1]));
    } else {
      return old(name);
    }
  };
};

Object.defineProperty(requireG, 'modulesPath', { get: function get() {
    return modulesPath;
  }, configurable: true });

Object.defineProperty(requireG, 'modules', { get: modules });

requireG.register = register;

module.exports = requireG;